import firebase from 'firebase';
import { Ref } from 'vue-demi';

declare type FirebaseDocRef<T> = firebase.firestore.Query<T> | firebase.firestore.DocumentReference<T>;
declare function useFirestore<T extends firebase.firestore.DocumentData>(docRef: firebase.firestore.DocumentReference<T>, errorHandler?: (err: Error) => void): Ref<T | null>;
declare function useFirestore<T extends firebase.firestore.DocumentData>(docRef: firebase.firestore.Query<T>, errorHandler?: (err: Error) => void): Ref<T[]>;

declare function useRTDB(docRef: firebase.database.Reference): any;

export { FirebaseDocRef, useFirestore, useRTDB };
